#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum OutputFormat {
    #[serde(rename = "ARROW_V4")]
    ArrowV4,
    #[serde(rename = "ARROW_V3")]
    ArrowV3,
    #[serde(rename = "LEGACY")]
    Legacy,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl OutputFormat {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            OutputFormat::ArrowV4 => "ARROW_V4",
            OutputFormat::ArrowV3 => "ARROW_V3",
            OutputFormat::Legacy => "LEGACY",
            OutputFormat::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for OutputFormat {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for OutputFormat {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for OutputFormat {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<OutputFormat, conjure_object::plain::ParseEnumError> {
        match v {
            "ARROW_V4" => Ok(OutputFormat::ArrowV4),
            "ARROW_V3" => Ok(OutputFormat::ArrowV3),
            "LEGACY" => Ok(OutputFormat::Legacy),
            v => v.parse().map(|v| OutputFormat::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for OutputFormat {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<OutputFormat, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the OutputFormat enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
